local require = GLOBAL.require
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local ACTIONS = GLOBAL.ACTIONS
local Action = GLOBAL.Action
        TECH = GLOBAL.TECH

STRINGS.NAMES.WARRACK = "Warrack"
STRINGS.CHARACTER_TITLES.warrack = "The Previously Chewed"
STRINGS.CHARACTER_NAMES.warrack = "Warrack, The Prechewed"
STRINGS.CHARACTER_DESCRIPTIONS.warrack = "*Is a tree\n*Smells like outdoors\n*Does not like fire"
STRINGS.CHARACTER_QUOTES.warrack = "\"What am I?\""
STRINGS.CHARACTERS.WARRACK = require "speech_warrack"
STRINGS.CHARACTERS.WARRACK.DESCRIBE.FANCYBAG = "It's just a school-bag..."
STRINGS.CHARACTERS.WARRACK.DESCRIBE.WARRACK = "Chop her down!"
	--If character prefab ~= accordalione then negative aura large*3 onequip

PrefabFiles = {
	"warrack",
}

Assets = {
	Asset( "IMAGE", "images/saveslot_portraits/warrack.tex"),
	Asset( "ATLAS", "images/saveslot_portraits/warrack.xml"),
	
	Asset( "IMAGE", "images/selectscreen_portraits/warrack.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/warrack.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/warrack_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/warrack_silho.xml" ),

    Asset( "IMAGE", "bigportraits/warrack.tex" ),
    Asset( "ATLAS", "bigportraits/warrack.xml" ),

    Asset( "IMAGE", "minimap/warrack.tex" ),
    Asset( "ATLAS", "minimap/warrack.xml" ),
	
--	Asset("SOUNDPACKAGE", "sound/warrack.fev"),
  --  Asset("SOUND", "sound/warrack.fsb"),
	}

GetPlayer = GLOBAL.GetPlayer
AddMinimapAtlas("minimap/warrack.xml")


--Revisit when you record either the "that thing" or the "this thing"
--RemapSoundEvent( "dontstarve/characters/warrack/death_voice", "warrack/characters/warrack/death_voice" )
--RemapSoundEvent( "dontstarve/characters/warrack/hurt", "warrack/characters/warrack/hurt" )
--RemapSoundEvent( "dontstarve/characters/warrack/talk_LP", "warrack/characters/warrack/talk_LP" )


GLOBAL.STRINGS.CHARACTERS.WARRACK = GLOBAL.require("speech_warrack")

AddModCharacter("warrack")
table.insert(GLOBAL.CHARACTER_GENDERS.ROBOT, "warrack")
--local atlas = (table.contains(MODCHARACTERLIST, character) and "images/saveslot_portraits/"..character..".xml") or "images/saveslot_portraits.xml"
--DECEASED.portrait:SetTexture(atlas, character..".tex")

local isWarrack = function()
	if GetPlayer().prefab == "warrack" then
		return true
	else
		return false
	end
end

local function treefall(inst)
	inst:ListenForEvent("workfinished", function(inst)
		if isWarrack() then
			local player = GetPlayer()
			local dist = 100
			if inst.Transform:GetWorldPosition() then
				local treept = GLOBAL.Vector3(inst.Transform:GetWorldPosition())
				local playerpt = GLOBAL.Vector3(player.Transform:GetWorldPosition())
				dist = math.sqrt((treept.x-playerpt.x)*(treept.x-playerpt.x)+(treept.y-playerpt.y)*(treept.y-playerpt.y)+(treept.z-playerpt.z)*(treept.z-playerpt.z))				
			end
			if not inst:HasTag("burning")
			and not inst:HasTag("burnt")
			and not inst:HasTag("monster")
			and dist <= 30 then
				local s = 2
				if inst.components.growable then 
					s = s + inst.components.growable.stage
				end
				if s > 5 then s = 2 end
				player.components.talker:Say("I'm sorry, Mr. Tree!")
				player.components.sanity:DoDelta(-s)
			end
		end
	end)
end
	
AddPrefabPostInit("evergreen", 	treefall)
AddPrefabPostInit("evergreen_normal", treefall)
AddPrefabPostInit("evergreen_tall", treefall)
AddPrefabPostInit("evergreen_short", treefall)


AddPrefabPostInit("evergreen_sparse", treefall)
AddPrefabPostInit("evergreen_sparse_normal", treefall)
AddPrefabPostInit("evergreen_sparse_tall", treefall)
AddPrefabPostInit("evergreen_sparse_short", treefall)

AddPrefabPostInit("deciduoustree", treefall)
AddPrefabPostInit("deciduoustree_normal", treefall)
AddPrefabPostInit("deciduoustree_tall", treefall)
AddPrefabPostInit("deciduoustree_short", treefall)

AddPrefabPostInit("marsh_tree", treefall)
AddPrefabPostInit("cave_banana_tree", treefall)

for k, v in pairs(CHARACTERLIST) do
    if v.prefab ~= "willow" then
        AddPrefabPostInit(v, ModCharacterInit)
    end
end

for k,v  in pairs(GLOBAL.MODCHARACTERLIST) do
    AddPrefabPostInit(v, ModCharacterInit)
end

local function AoSFix(inst) 
inst:AddComponent("switch") 
end 

for _, moddir in ipairs(GLOBAL.KnownModIndex:GetModsToLoad()) do 
if GLOBAL.KnownModIndex:GetModInfo(moddir).name == "Always On Status" then 
AddPrefabPostInit("warrack", AoSFix) 
end 
end
